BOOT:
  {
#if defined(dTHX) && !defined(PERL_NO_GET_CONTEXT)
    dTHX;
#endif
    HV *symbol_table = get_hv("Ouroboros::", GV_ADD);
    AV *push = get_av("Ouroboros::CONSTS", GV_ADD);
    HE *he;

    static const struct iv_s values_for_iv[] =
      {
        { "SVt_NULL", 8, SVt_NULL },
        { "SVt_IV", 6, SVt_IV },
        { "SVt_NV", 6, SVt_NV },
        { "SVt_PV", 6, SVt_PV },
        { "SVt_PVIV", 8, SVt_PVIV },
        { "SVt_PVNV", 8, SVt_PVNV },
        { "SVt_PVMG", 8, SVt_PVMG },
        { "SVt_REGEXP", 10, SVt_REGEXP },
        { "SVt_PVGV", 8, SVt_PVGV },
        { "SVt_PVLV", 8, SVt_PVLV },
        { "SVt_PVAV", 8, SVt_PVAV },
        { "SVt_PVHV", 8, SVt_PVHV },
        { "SVt_PVCV", 8, SVt_PVCV },
        { "SVt_PVFM", 8, SVt_PVFM },
        { "SVt_PVIO", 8, SVt_PVIO },
        { "SVt_LAST", 8, SVt_LAST },
        { NULL, 0, 0 } };
	const struct iv_s *value_for_iv = values_for_iv;

    static const struct uv_s values_for_uv[] =
      {
#ifdef SV_CATBYTES
        { "SV_CATBYTES", 11, SV_CATBYTES },
#endif
#ifdef SV_CATUTF8
        { "SV_CATUTF8", 10, SV_CATUTF8 },
#endif
#ifdef SV_CONST_RETURN
        { "SV_CONST_RETURN", 15, SV_CONST_RETURN },
#endif
#ifdef SV_COW_DROP_PV
        { "SV_COW_DROP_PV", 14, SV_COW_DROP_PV },
#endif
#ifdef SV_FORCE_UTF8_UPGRADE
        { "SV_FORCE_UTF8_UPGRADE", 21, SV_FORCE_UTF8_UPGRADE },
#endif
#ifdef SV_GMAGIC
        { "SV_GMAGIC", 9, SV_GMAGIC },
#endif
#ifdef SV_HAS_TRAILING_NUL
        { "SV_HAS_TRAILING_NUL", 19, SV_HAS_TRAILING_NUL },
#endif
#ifdef SV_IMMEDIATE_UNREF
        { "SV_IMMEDIATE_UNREF", 18, SV_IMMEDIATE_UNREF },
#endif
#ifdef SV_NOSTEAL
        { "SV_NOSTEAL", 10, SV_NOSTEAL },
#endif
#ifdef SV_SMAGIC
        { "SV_SMAGIC", 9, SV_SMAGIC },
#endif
#ifdef GV_ADD
        { "GV_ADD", 6, GV_ADD },
#endif
#ifdef GV_ADDMG
        { "GV_ADDMG", 8, GV_ADDMG },
#endif
#ifdef GV_ADDMULTI
        { "GV_ADDMULTI", 11, GV_ADDMULTI },
#endif
#ifdef GV_NOADD_NOINIT
        { "GV_NOADD_NOINIT", 15, GV_NOADD_NOINIT },
#endif
#ifdef GV_NOEXPAND
        { "GV_NOEXPAND", 11, GV_NOEXPAND },
#endif
#ifdef GV_NOINIT
        { "GV_NOINIT", 9, GV_NOINIT },
#endif
#ifdef GV_SUPER
        { "GV_SUPER", 8, GV_SUPER },
#endif
#ifdef PERL_MAGIC_arylen
        { "PERL_MAGIC_arylen", 17, PERL_MAGIC_arylen },
#endif
#ifdef PERL_MAGIC_arylen_p
        { "PERL_MAGIC_arylen_p", 19, PERL_MAGIC_arylen_p },
#endif
#ifdef PERL_MAGIC_backref
        { "PERL_MAGIC_backref", 18, PERL_MAGIC_backref },
#endif
#ifdef PERL_MAGIC_bm
        { "PERL_MAGIC_bm", 13, PERL_MAGIC_bm },
#endif
#ifdef PERL_MAGIC_checkcall
        { "PERL_MAGIC_checkcall", 20, PERL_MAGIC_checkcall },
#endif
#ifdef PERL_MAGIC_collxfrm
        { "PERL_MAGIC_collxfrm", 19, PERL_MAGIC_collxfrm },
#endif
#ifdef PERL_MAGIC_dbfile
        { "PERL_MAGIC_dbfile", 17, PERL_MAGIC_dbfile },
#endif
#ifdef PERL_MAGIC_dbline
        { "PERL_MAGIC_dbline", 17, PERL_MAGIC_dbline },
#endif
#ifdef PERL_MAGIC_debugvar
        { "PERL_MAGIC_debugvar", 19, PERL_MAGIC_debugvar },
#endif
#ifdef PERL_MAGIC_defelem
        { "PERL_MAGIC_defelem", 18, PERL_MAGIC_defelem },
#endif
#ifdef PERL_MAGIC_env
        { "PERL_MAGIC_env", 14, PERL_MAGIC_env },
#endif
#ifdef PERL_MAGIC_envelem
        { "PERL_MAGIC_envelem", 18, PERL_MAGIC_envelem },
#endif
#ifdef PERL_MAGIC_ext
        { "PERL_MAGIC_ext", 14, PERL_MAGIC_ext },
#endif
#ifdef PERL_MAGIC_fm
        { "PERL_MAGIC_fm", 13, PERL_MAGIC_fm },
#endif
#ifdef PERL_MAGIC_foo
        { "PERL_MAGIC_foo", 14, PERL_MAGIC_foo },
#endif
#ifdef PERL_MAGIC_hints
        { "PERL_MAGIC_hints", 16, PERL_MAGIC_hints },
#endif
#ifdef PERL_MAGIC_hintselem
        { "PERL_MAGIC_hintselem", 20, PERL_MAGIC_hintselem },
#endif
#ifdef PERL_MAGIC_isa
        { "PERL_MAGIC_isa", 14, PERL_MAGIC_isa },
#endif
#ifdef PERL_MAGIC_isaelem
        { "PERL_MAGIC_isaelem", 18, PERL_MAGIC_isaelem },
#endif
#ifdef PERL_MAGIC_lvref
        { "PERL_MAGIC_lvref", 16, PERL_MAGIC_lvref },
#endif
#ifdef PERL_MAGIC_nkeys
        { "PERL_MAGIC_nkeys", 16, PERL_MAGIC_nkeys },
#endif
#ifdef PERL_MAGIC_overload_table
        { "PERL_MAGIC_overload_table", 25, PERL_MAGIC_overload_table },
#endif
#ifdef PERL_MAGIC_pos
        { "PERL_MAGIC_pos", 14, PERL_MAGIC_pos },
#endif
#ifdef PERL_MAGIC_qr
        { "PERL_MAGIC_qr", 13, PERL_MAGIC_qr },
#endif
#ifdef PERL_MAGIC_regdata
        { "PERL_MAGIC_regdata", 18, PERL_MAGIC_regdata },
#endif
#ifdef PERL_MAGIC_regdatum
        { "PERL_MAGIC_regdatum", 19, PERL_MAGIC_regdatum },
#endif
#ifdef PERL_MAGIC_regex_global
        { "PERL_MAGIC_regex_global", 23, PERL_MAGIC_regex_global },
#endif
#ifdef PERL_MAGIC_rhash
        { "PERL_MAGIC_rhash", 16, PERL_MAGIC_rhash },
#endif
#ifdef PERL_MAGIC_shared
        { "PERL_MAGIC_shared", 17, PERL_MAGIC_shared },
#endif
#ifdef PERL_MAGIC_shared_scalar
        { "PERL_MAGIC_shared_scalar", 24, PERL_MAGIC_shared_scalar },
#endif
#ifdef PERL_MAGIC_sig
        { "PERL_MAGIC_sig", 14, PERL_MAGIC_sig },
#endif
#ifdef PERL_MAGIC_sigelem
        { "PERL_MAGIC_sigelem", 18, PERL_MAGIC_sigelem },
#endif
#ifdef PERL_MAGIC_substr
        { "PERL_MAGIC_substr", 17, PERL_MAGIC_substr },
#endif
#ifdef PERL_MAGIC_sv
        { "PERL_MAGIC_sv", 13, PERL_MAGIC_sv },
#endif
#ifdef PERL_MAGIC_symtab
        { "PERL_MAGIC_symtab", 17, PERL_MAGIC_symtab },
#endif
#ifdef PERL_MAGIC_taint
        { "PERL_MAGIC_taint", 16, PERL_MAGIC_taint },
#endif
#ifdef PERL_MAGIC_tied
        { "PERL_MAGIC_tied", 15, PERL_MAGIC_tied },
#endif
#ifdef PERL_MAGIC_tiedelem
        { "PERL_MAGIC_tiedelem", 19, PERL_MAGIC_tiedelem },
#endif
#ifdef PERL_MAGIC_tiedscalar
        { "PERL_MAGIC_tiedscalar", 21, PERL_MAGIC_tiedscalar },
#endif
#ifdef PERL_MAGIC_utf8
        { "PERL_MAGIC_utf8", 15, PERL_MAGIC_utf8 },
#endif
#ifdef PERL_MAGIC_uvar
        { "PERL_MAGIC_uvar", 15, PERL_MAGIC_uvar },
#endif
#ifdef PERL_MAGIC_uvar_elem
        { "PERL_MAGIC_uvar_elem", 20, PERL_MAGIC_uvar_elem },
#endif
#ifdef PERL_MAGIC_vec
        { "PERL_MAGIC_vec", 14, PERL_MAGIC_vec },
#endif
#ifdef PERL_MAGIC_vstring
        { "PERL_MAGIC_vstring", 18, PERL_MAGIC_vstring },
#endif
        { NULL, 0, 0 } };
	const struct uv_s *value_for_uv = values_for_uv;
        while (value_for_iv->name) {
	    he = constant_add_symbol(aTHX_  symbol_table, value_for_iv->name,
				     value_for_iv->namelen, newSViv(value_for_iv->value));
	    av_push(push, newSVhek(HeKEY_hek(he)));
            ++value_for_iv;
	}
        while (value_for_uv->name) {
	    he = constant_add_symbol(aTHX_  symbol_table, value_for_uv->name,
				     value_for_uv->namelen, newSVuv(value_for_uv->value));
	    av_push(push, newSVhek(HeKEY_hek(he)));
            ++value_for_uv;
	}
	if (C_ARRAY_LENGTH(values_for_notfound) > 1) {
#ifndef SYMBIAN
	    HV *const constant_missing = get_missing_hash(aTHX);
#endif
	    const struct notfound_s *value_for_notfound = values_for_notfound;
	    do {

		/* Need to add prototypes, else parsing will vary by platform.  */
		HE *he = (HE*) hv_common_key_len(symbol_table,
						 value_for_notfound->name,
						 value_for_notfound->namelen,
						 HV_FETCH_LVALUE, NULL, 0);
		SV *sv;
#ifndef SYMBIAN
		HEK *hek;
#endif
		if (!he) {
		    croak("Couldn't add key '%s' to %%Ouroboros::",
			  value_for_notfound->name);
		}
		sv = HeVAL(he);
		if (!SvOK(sv) && SvTYPE(sv) != SVt_PVGV) {
		    /* Nothing was here before, so mark a prototype of ""  */
		    sv_setpvn(sv, "", 0);
		} else if (SvPOK(sv) && SvCUR(sv) == 0) {
		    /* There is already a prototype of "" - do nothing  */
		} else {
		    /* Someone has been here before us - have to make a real
		       typeglob.  */
		    /* It turns out to be incredibly hard to deal with all the
		       corner cases of sub foo (); and reporting errors correctly,
		       so lets cheat a bit.  Start with a constant subroutine  */
		    CV *cv = newCONSTSUB(symbol_table,
					 value_for_notfound->name,
					 &PL_sv_yes);
		    /* and then turn it into a non constant declaration only.  */
		    SvREFCNT_dec(CvXSUBANY(cv).any_ptr);
		    CvCONST_off(cv);
		    CvXSUB(cv) = NULL;
		    CvXSUBANY(cv).any_ptr = NULL;
		}
#ifndef SYMBIAN
		hek = HeKEY_hek(he);
		if (!hv_common(constant_missing, NULL, HEK_KEY(hek),
 			       HEK_LEN(hek), HEK_FLAGS(hek), HV_FETCH_ISSTORE,
			       &PL_sv_yes, HEK_HASH(hek)))
		    croak("Couldn't add key '%s' to missing_hash",
			  value_for_notfound->name);
#endif
		av_push(push, newSVhek(hek));
	    } while ((++value_for_notfound)->name);
	}
    /* As we've been creating subroutines, we better invalidate any cached
       methods  */
    mro_method_changed_in(symbol_table);
  }

void
constant(sv)
    INPUT:
	SV *		sv;
    PPCODE:
#ifndef SYMBIAN
	/* It's not obvious how to calculate this at C pre-processor time.
	   However, any compiler optimiser worth its salt should be able to
	   remove the dead code, and hopefully the now-obviously-unused static
	   function too.  */
	HV *constant_missing = (C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? get_missing_hash(aTHX) : NULL;
	if ((C_ARRAY_LENGTH(values_for_notfound) > 1)
	    ? hv_exists_ent(constant_missing, sv, 0) : 0) {
	    sv = newSVpvf("Your vendor has not defined Ouroboros macro %" SVf
			  ", used", sv);
	} else
#endif
	{
	    sv = newSVpvf("%" SVf " is not a valid Ouroboros macro",
			  sv);
	}
	PUSHs(sv_2mortal(sv));
